<?php

namespace App\Models;

use App\Http\Helpers\Hasher;

use Illuminate\Database\Eloquent\Model;
use Carbon\Carbon;

class ContractTemplate extends Model
{
    protected $table = 'contract_templates';

     protected $appends = ['hash_id', 'contract_template_obligation_list'];

    public function contract_template_obligation()
    {
        return $this->hasMany('App\Models\ContractTemplateObligation', 'contract_template_id');
    }

    public function getHashIdAttribute()
    {
        return Hasher::encode('contract_templates', $this->id);
    }

    public function getContractTemplateObligationListAttribute()
    {
        return $this->contract_template_obligation()
        ->orderBy('sequence', 'asc')
        ->where('status', config('constants.contract_template_obligation.status.active'))
        ->get()
        ->makeHidden(['contract_template_list']);
    }

    public function getUpdatedAtAttribute($date) 
    {
        return $date ? Carbon::parse($date)->timezone('Asia/Kuala_Lumpur')->format('Y-m-d') : '';
    }

    public function getCreatedAtAttribute($date) 
    {
        return $date ? Carbon::parse($date)->timezone('Asia/Kuala_Lumpur')->format('Y-m-d') : '';
    }
}
